package de.fraunhofer.iem.dataprovider.kpi.strategy

import de.fraunhofer.iem.dataprovider.kpi.dto.KPIHierarchyEdgeDto

class RatioKPICalculationStrategy : KPICalculationStrategy {
    override fun calculateKPI(children: List<KPIHierarchyEdgeDto>): Int {
        if (children.size != 2) {
            throw Exception("Requires exactly two children")
        }
        val firstValue = children[0].to.getValue()
        val secondValue = children[1].to.getValue()
        if (firstValue >= secondValue) {
            return ((secondValue.toDouble() / firstValue.toDouble()) * 100).toInt()
        }
        return ((firstValue.toDouble() / secondValue.toDouble()) * 100).toInt()
    }
}
