package de.fraunhofer.iem.dataprovider.repository.entity


import de.fraunhofer.iem.dataprovider.toolRun.entity.ToolRunEntity
import jakarta.persistence.*
import org.hibernate.annotations.CurrentTimestamp
import org.hibernate.annotations.UpdateTimestamp
import org.hibernate.generator.EventType
import java.time.Instant
import java.util.*

@Entity
@Table(name = "repository")
class RepositoryEntity(

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    var id: UUID? = null,

    @OrderBy("last_updated_at DESC")
    @OneToMany(
        mappedBy = "repository",
        cascade = [CascadeType.MERGE, CascadeType.REFRESH, CascadeType.REMOVE, CascadeType.DETACH],
        orphanRemoval = true
    )
    val toolRuns: MutableList<ToolRunEntity> = mutableListOf(),

    @Column(name = "name", nullable = false)
    val name: String,

    @Column(name = "repo_id", nullable = false)
    val repoId: Long,

    @Column(name = "url", nullable = false)
    val url: String,

    @CurrentTimestamp(event = [EventType.INSERT])
    var createdAt: Instant? = null,

    @UpdateTimestamp
    var lastUpdatedAt: Instant? = null
) {

    fun addToolResult(toolRun: ToolRunEntity) {
        toolRuns.add(toolRun)
    }
}
